@rem   	BSI Pre Script to detect version and prompt for 
@rem   	credentials if needed
@rem   	Based on autoCheck.bat created by Scott Karbiner
@rem    Updated for CACDF 02-26-13 by haemi01
@rem    Updated to include CACDF GUI prompts and password masking (haemi01) 
@rem    10-01-13 (haemi01) Updated to change location of scripts in Remote Engineer 

@cls
@echo off
SETLOCAL EnableDelayedExpansion

@rem AutoCheck.bat pre preperation of folders/values
@rem
if not exist logs mkdir logs
set Log="logs\autoCheck.log"
@rem location of Custom SQL scripts for BSI
set SQL="scripts\SQLs"
@rem location of Custom VBS scripts for BSI
set VBS="scripts\VBSs"

echo Last Run: %date% %time% >%Log%
echo. >>%Log%

echo Pre populated check started
echo.

@rem IF preferred the values needed can be pre populated in the autoCheck.ini file
@rem Getting values from autoCheck.ini file
echo.
echo Checking for autoCheck.ini for pre polulated values
for /f "tokens=1,2 usebackq delims==" %%a in ( autoCheck.ini ) do (					 
	if %%a == OBLICORE_INSTALL_PATH	(set OBLICORE_INSTALL_PATH=%%b)
	if %%a == WEB_SERVER	(set WEB_SERVER=%%b)
	if %%a == APP_SERVER	(set APP_SERVER=%%b)
	if %%a == DB_SERVER	(set DB_SERVER=%%b)
 	if %%a == DB_NAME	(set DB_NAME=%%b)
	if %%a == OBLICORE_USER (set OBLICORE_USER=%%b)
 	if %%a == OBLICORE_PASS (set OBLICORE_PASS=%%b)	
	if %%a == SYS_USER	(set SYS_USER=%%b)
	if %%a == SYS_PASS	(set SYS_PASS=%%b)
	if %%a == COLLECT_ADAPTER_FOLDER_INFO	(set COLLECT_ADAPTER_FOLDER_INFO=%%b)
	if %%a == RUN_BIGS_WITH_ROOT_CAUSE_REPORT	(set RUN_BIGS_WITH_ROOT_CAUSE_REPORT=%%b)
	if %%a == RUN_ADMIN_REPORTS_PSL_BY_CONTRACT	(set RUN_ADMIN_REPORTS_PSL_BY_CONTRACT=%%b)
)

echo Pre populated check finished
echo.
@rem End of AutoCheck pre value/variable checking
@rem =============================================
@rem

echo.
echo BSI Information processing
echo.
if "%OBLICORE_USER%." equ "." (
echo Pre populated values not detected in the autoCheck.ini file
echo Running interactive mode to prompt for required values
)

@rem Add detection of product Version
@rem If version has ID/PASS values stored in file, gather and utilize.
@rem else proceed below for interactive prompting
@rem

if "%OBLICORE_USER%." equ "." (
echo.
echo Please enter the BSI Database User ID to collect information ^>^>
set /p OBLICORE_USER=
) 

@rem Need ENHANCEMENT to CACDF to be able to hide the password when entered
if "%OBLICORE_PASS%." equ "." (
echo.
echo Please enter the BSI DB user password p^>^>
set /p OBLICORE_PASS=
) 

if "%DB_SERVER%." equ "." (
echo.
echo Please enter the BSI Database server name ^>^>
set /p DB_SERVER=
)

if "%DB_NAME%." equ "." (
echo.
echo Please enter the BSI Service Name or TNS Name ^>^>
set /p DB_NAME=
)

@rem Check if OG_HOME variable is set
if "%OG_HOME%." neq "." (
set OBLICORE_INSTALL_PATH=%OG_HOME%
)

@rem
if "%OBLICORE_INSTALL_PATH%." equ "." (
echo.
echo Please enter the BSI Install Path, eg. C:\program files\oblicore ^>^>
set /p OBLICORE_INSTALL_PATH=
)

if "%WEB_SERVER%." equ "." (
echo.
echo Please enter the webserver name ^>^>
set /p WEB_SERVER=
)

if "%APP_SERVER%." equ "." (
echo.
echo Please enter the Application Server name ^>^>
set /p APP_SERVER=
)
@rem Enhancement: Get adapter folder
@rem Would you like to collect the adapter folder? 
@rem If you store client data or data is too large you may want to select no.
@rem if "%COLLECT_ADAPTER_FOLDER_INFO%" == "YES"
if "%COLLECT_ADAPTER_FOLDER_INFO%" == "YES" (
echo "COLLECT_ADAPTER_FOLDER_INFO already set to %COLLECT_ADAPTER_FOLDER_INFO%"
)
if "%COLLECT_ADAPTER_FOLDER_INFO%." equ "." (
echo.
echo Would you like to collect the adapter folder? "(y/n)" ^>^>
echo If you store client data or data is too large you may want to select no
set /p COLLECT_ADAPTER_FOLDER_INFO=
)
@rem check to see if user said yes
if "%COLLECT_ADAPTER_FOLDER_INFO%." equ "y." (
set GATHER_ADAPTERS=%OG_HOME%
)
@rem check to see if user said yes
if "%COLLECT_ADAPTER_FOLDER_INFO%." equ "Y." (
set GATHER_ADAPTERS=%OG_HOME%
)
@rem check to see if user said yes
if "%COLLECT_ADAPTER_FOLDER_INFO%." equ "Yes." (
set GATHER_ADAPTERS=%OG_HOME%
)
@rem check to see if user said yes
if "%COLLECT_ADAPTER_FOLDER_INFO%." equ "yes." (
set GATHER_ADAPTERS=%OG_HOME%
)
@rem Below echo's for testing only
echo.
echo "COLLECT_ADAPTER_FOLDER_INFO set to" "%COLLECT_ADAPTER_FOLDER_INFO%"
echo "GATHER_ADAPTERS Set to" "%GATHER_ADAPTERS%"
echo "%GATHER_ADAPTERS%">GATHER_ADAPTERS.out
echo "OBLICORE_INSTALL_PATH set to" %OBLICORE_INSTALL_PATH%
echo "OG_HOME is set to" "%OG_HOME%"

@rem =====================================================
@rem Continuation of autoCheck.bat

CALL :UpCase COLLECT_ADAPTER_FOLDER_INFO
CALL :UpCase RUN_BIGS_WITH_ROOT_CAUSE_REPORT
CALL :UpCase RUN_ADMIN_REPORTS_PSL_BY_CONTRACT

Rem if any of the values are still null set to undefined
if "%OBLICORE_INSTALL_PATH%"==""  set OBLICORE_INSTALL_PATH=undefined 
if "%WEB_SERVER%"=="" set WEB_SERVER=undefined
if "%APP_SERVER%"=="" set APP_SERVER=undefined
if "%DB_SERVER%"=="" set DB_SERVER=undefined
if "%DB_NAME%"=="" set DB_NAME=undefined 
if "%OBLICORE_USER%"=="" set OBLICORE_USER=undefined
if "%OBLICORE_PASS%"=="" set OBLICORE_PASS=undefined 
if "%SYS_USER%"=="" set SYS_USER=undefined
if "%SYS_PASS%"=="" set SYS_PASS=undefined 
if "%COLLECT_BASIC_ADAPTER_FOLDER_INFO%"=="" set COLLECT_BASIC_ADAPTER_FOLDER_INFO=undefined
if "%RUN_BIGS_WITH_ROOT_CAUSE_REPORT%"=="" set RUN_BIGS_WITH_ROOT_CAUSE_REPORT=undefined
if "%RUN_ADMIN_REPORTS_PSL_BY_CONTRACT%"=="" set RUN_ADMIN_REPORTS_PSL_BY_CONTRACT=undefined 


REM ************************************************
REM Using VBS to parse the registry.xml file and pass it back to the batch
REM I could process it in the vbs file as well, but this gives us a lot
REM of flexibility for the future since we have the data here now as well.
REM ************************************************

Rem Getting values from registry.xml file
start /B /WAIT cscript //nologo %VBS%\readRegistry.vbs "%OBLICORE_INSTALL_PATH%" >>%Log%

echo --- checking registry.xml user logins and their roles --- >>%Log%
echo. >>%Log%

for /f "tokens=1,2,3,4 usebackq delims==" %%a in ( logs\regXml.ini ) do (					 
	if %%d == end	(
		set DataSource=%%a
		set User=%%b	
		set Password=%%c
		echo CHECKING: %%b\%%c@%%a >> logs\autoCheck.log
		sqlplus -L /nolog @%SQL%\validateUsers.sql %%b %%c %%a
		more logs\validateUsers.log >> logs\autoCheck.log
	)
)

del logs\regXml.ini
del logs\validateUsers.log
echo. >>%Log%


REM ************************************************
REM Get the Oracle versions.
REM ************************************************
REM client....
echo --- sqlplus client version --- >>%Log%
sqlplus -V >>%Log%

REM server....
echo --- oracle server version --- >>%Log%
sqlplus /nolog @%SQL%\invalidObjects.sql %OBLICORE_USER% %OBLICORE_PASS% %DB_NAME% >>%Log%
echo. >>%Log%
echo ----------------------------------------------- >>%Log%


REM ************************************************
REM Dumping the tables,views,t_system_configurations,v$nls_parameters to csv files
REM ************************************************
sqlplus /nolog @%SQL%\getTables.sql %OBLICORE_USER% %OBLICORE_PASS% %DB_NAME%


REM ************************************************
REM Check the Oblicore versions in registry and dump registry
REM ************************************************
echo --- Checking the product version in the registry --- >>%Log%
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Oblicore\ >logs\versions.log
start /B /WAIT cscript //nologo %VBS%\checkVersions.vbs >>%Log%
del logs\versions.log

reg export HKEY_LOCAL_MACHINE\SOFTWARE\Oblicore logs\appRegistry.reg /y


REM ************************************************
REM Checking the tablespaces for size.
REM ************************************************
echo --- trying to connect as SYS with AS SYSDBA to check tablespaces --- >>%Log%
sqlplus -L -S /nolog @%SQL%\tbSpaceCheck.sql %SYS_USER% %SYS_PASS% %DB_NAME% >>%Log%
echo ==================================================================== >>%Log%


REM ************************************************
REM Compare the tables and views with our example lists
REM ************************************************
start /B /WAIT cscript //nologo %VBS%\compareLists.vbs >>%Log%
echo. >>%Log%
echo --- checking tables and views for any missing --- >>%Log%
echo. >>%Log%
more logs\tables.log >> logs\autoCheck.log
del logs\tables.log
echo ------------------------------------------------->>%Log%


REM ************************************************
REM Check name resolution
REM ************************************************
echo --- Checking name resolution --- >>%Log%
echo. >>%Log%
echo local hostname comes back as >>%Log%
hostname >>%Log%
echo this should match the app server you specified in the ini file below: >>%Log%
start /B /WAIT cscript //nologo %VBS%\checkNameResolution.vbs %APP_SERVER% >>%Log%
more checkNameResolution.log >> logs\autoCheck.log
del checkNameResolution.log
echo. >>%Log%


REM ************************************************
REM Checking character sets
REM ************************************************
echo --- Checking character sets --- >>%Log%
echo Oblicore requires charactersets of UTF8 or we8mswin1252 >>%Log%
echo It IS ok for the NLS_NCHAR_CHARACTERSET to be AL16UTF16 >>%Log%
echo. >>%Log%
start /B /WAIT cscript //nologo %VBS%\checkCharSets.vbs >>%Log%
more logs\checkCharSets.log >> logs\autoCheck.log
del logs\checkCharSets.log
echo. >>%Log%


REM ************************************************
REM Checking for invalid objects. There should be none.
REM ************************************************
echo --- Checking for invalid objects. There should be NONE --- >>%Log%
sqlplus /nolog @%SQL%\invalidObjects.sql %OBLICORE_USER% %OBLICORE_PASS% %DB_NAME% >>%Log%
echo ---------------------------------------------------------- >>%Log%
echo. >>%Log%
echo Please review the log file under the logs folder carefully. This program will >>%Log%
echo not validate everything. While it will check some basic information, you still >>%Log%
echo need to review the log information to manually check for problems. >>%Log%
echo. >>%Log%


REM ************************************************
REM Run some of the PSL reports
REM ************************************************
echo --- Running some of the PSL reports --- >>%Log%
echo. >>%Log%
if "%RUN_BIGS_WITH_ROOT_CAUSE_REPORT%" == "YES" (sqlplus /nolog @%SQL%\bigS_with_root_cause.sql %OBLICORE_USER% %OBLICORE_PASS% %DB_NAME%)
if "%RUN_ADMIN_REPORTS_PSL_BY_CONTRACT%" == "YES" (sqlplus /nolog @%SQL%\admin_reports_PSL_by_contract.sql %OBLICORE_USER% %OBLICORE_PASS% %DB_NAME%)
echo. >>%Log%


REM ************************************************
REM Checking the MSMQs
REM ************************************************
echo --- Checking the Queues on the Web server --- >>%Log%
echo. >>%Log%
start /B /WAIT cscript //nologo %VBS%\checkMSMQ.vbs >>%Log%
echo. >>%Log%


REM ************************************************
REM dumping the last 100 rows of t_log
REM ************************************************
echo --- dumping the last 100 rows of t_log --- >>%Log%
echo. >>%Log%
sqlplus /nolog @%SQL%\getLast100Tlog.sql %OBLICORE_USER% %OBLICORE_PASS% %DB_NAME%
echo. >>%Log%
echo --- getting the tops of logserver.log and logclient.log --- >>%Log%
start /B /WAIT cscript //nologo %VBS%\getLogs.vbs "%OBLICORE_INSTALL_PATH%" >>%Log%


REM ************************************************
REM get a netstat output
REM ************************************************
echo --- getting a netstat -vabn output --- >>%Log%
REM netstat -vabn > logs\netstat.log
echo. >>%Log%

if "%COLLECT_ADAPTER_FOLDER_INFO%" == "YES" CALL :FUNC_COLLECT_ADAPTER_FOLDER_INFO

GOTO:EOF

:UpCase
# Subroutine to convert a variable VALUE to all UPPER CASE.
# The argument for this subroutine is the variable NAME.
FOR %%i IN ("a=A" "b=B" "c=C" "d=D" "e=E" "f=F" "g=G" "h=H" "i=I" "j=J" "k=K" "l=L" "m=M" "n=N" "o=O" "p=P" "q=Q" "r=R" "s=S" "t=T" "u=U" "v=V" "w=W" "x=X" "y=Y" "z=Z") DO CALL SET "%1=%%%1:%%~i%%"
GOTO:EOF


:FUNC_COLLECT_ADAPTER_FOLDER_INFO
echo --- Collecting adapter information --- >>%Log%
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Oblicore\Adapters /f AdaptersDir >logs\adapters.log
sqlplus /nolog @%SQL%\getAdapters.sql %OBLICORE_USER% %OBLICORE_PASS% %DB_NAME%
start /B /WAIT cscript //nologo %VBS%\collectAdapter.vbs "%OBLICORE_INSTALL_PATH%" >>%Log%
del logs\adapters.log
GOTO:EOF

