--whenever sqlerror exit sql.sqlcode;
--whenever oserror exit -1;

define owner=&1

-- This script will accept an input parm for the database schema owner and run a series of queries to obtain customer information related to their Data Manager / CCC product

SET verify off
SET colsep '|'
SET echo OFF
SET feedback OFF
SET linesize 1000
-- SET pagesize 0
SET sqlprompt ''
SET trimspool ON
SET headsep OFF
SET sqlcase upper

spool sqloutput.dat

-- Oracle version

SELECT BANNER AS "ORACLE RELEASE VERSION" FROM v$version;

--DM version
SELECT VERSION AS "DM VERSION", START_DATE AS "START_DATE", END_DATE AS "END_DATE" FROM &OWNER..version_config;

-- CCC version
SELECT VERSION AS "CCC VERSION", START_DATE AS "START_DATE", END_DATE AS "END_DATE", UPGRADE AS "UPGRADE" FROM &OWNER..ccc_version_config;

-- CCC baseline
SELECT BASELINE_ID AS "CCC BASELINE_ID", START_DATE AS "START_DATE", END_DATE AS "END_DATE", ROLLING AS "ROLLING" FROM &OWNER..baselines;

--DM various log & configuration information
SELECT * FROM &OWNER..datamanager_params_config;
SELECT * FROM &OWNER..source_type_config;
SELECT * FROM &OWNER..datasources_config;
SELECT * FROM &OWNER..changelog WHERE rownum <2000;
SELECT * FROM &OWNER..purge_log_config WHERE rownum <2000;
SELECT * FROM &OWNER..refresh_log_config WHERE rownum <2000;
SELECT * FROM &OWNER..Transactions_config WHERE rownum <2000;
SELECT * FROM &OWNER..logging_info_config WHERE rownum <2000;

--------  vb sql

select distinct physical_host, host_id, host_name,
       min(metric_date) as "min_metric_date", max(metric_date) as "max_metric_date"
from &OWNER..server_dim a, &OWNER..server_fact b
where a.server_dim_id = b.server_dim_id
group by physical_host, host_id, host_name
order by physical_host, host_id;

SELECT i.std_name,
  i.metric_dim_id,
  j.metric_source,
  i.total_metrics,
  i.min_metric_date,
  i.max_metric_date,
  h.metric_dim_id,
  h.server_count
FROM
  (SELECT c.std_name,
    c.metric_dim_id,
    COUNT(*)         AS total_metrics,
    MIN(metric_date) AS min_metric_date,
    MAX(metric_date) AS max_metric_date
  FROM server_fact a,
    server_dim b,
    metric_dim c
  WHERE a.server_dim_id = b.server_dim_id
  AND a.metric_dim_id   = c.metric_dim_id
  GROUP BY c.std_name,
    c.metric_dim_id
  ORDER BY c.std_name
  ) i,
  (SELECT g.metric_dim_id,
    COUNT(*) server_count
  FROM
    ( SELECT DISTINCT e.metric_dim_id,
      f.host_name
    FROM
      (SELECT DISTINCT metric_dim_id, server_dim_id FROM server_fact
      ) e,
      (SELECT DISTINCT host_name, server_dim_id FROM server_dim
      ) f
    WHERE e.server_dim_id = f.server_dim_id
    ) g
  GROUP BY g.metric_dim_id
  ) h,
  metric_dim j
WHERE i.metric_dim_id = h.metric_dim_id
AND i.metric_dim_id   = j.metric_dim_id
ORDER BY i.std_name,
  j.metric_source;


--------  vb sql

spool OFF
exit
