set echo off
set feedback off
set linesize 100
set pagesize 1000
set sqlPrompt ''
set trimspool on
set colsep ","

connect &1/&2@&3

SET MARKUP HTML ON SPOOL ON HEAD "<TITLE>Admin Report PSL By Contract</TITLE><STYLE TYPE='TEXT/CSS'><!--BODY {background: ffffc6} --></STYLE>"

spool logs\admin_reports_PSL_by_contract.htm
select t.sla_name "Contract",
       decode(not_fully_calculated, 0, 'YES', 'NO') "Contract Fully Calculated",
       decode(not_fully_calculated, 0, null, not_fully_calculated) "# of Metrics to Calculate",
       decode(run_time_error, 0, null, run_time_error) "# of Metrics with Error",
       decode(not_fully_calculated,
              0,
              '',
              to_char(t.calculation_valid_upto +
                      Fnc_Date_By_Locale(t.calculation_valid_upto,
                                         t.locale,
                                         1) / 24,
                      'DD-MON-YYYY HH:MI:SS AM')) "Requires Calculation From",
       to_char(t.rule_tu_modify_date +
               Fnc_Date_By_Locale(t.rule_tu_modify_date, t.locale, 1) / 24,
               'DD-MON-YYYY HH:MI:SS AM') "Last Update At"
  from (select s.sla_name,
               (select sys_config_value
                  from t_system_configurations
                 where sys_config_id = 31) locale,
               min(t.calculation_valid_upto) calculation_valid_upto,
               max(t.rule_tu_modify_date) rule_tu_modify_date,
               count(decode(t.agent_fully_calculated, 1, null, 1)) not_fully_calculated,
               count(t.last_rt_error_code) run_time_error
          from t_rules_time_units t,
               t_rules            r,
               t_sla_versions     sv,
               t_slas             s,
               t_global_rules     g
         where s.sla_id = sv.sla_id
           and sv.sla_version_id = r.sla_version_id
           and r.psl_rule_id = t.rule_id
           and sv.status in ('EFFECTIVE', 'NOT_EFFECTIVE')
           and s.sla_status != 'ARCHIVED'
           and t.status = 'ON'
           and r.measurability_status = 'TXT_MEASURABILITY_STATUS_ACTIVE'
           and r.global_rule_id = g.global_rule_id
           and lower(s.sla_name) like lower('%')
           and t.is_period = 1
         group by s.sla_name) t
 order by t.sla_name;
spool off
exit;
