set echo off
set feedback off
set linesize 100
set pagesize 1000
set sqlPrompt ''
set trimspool on
set colsep ","

connect &1/&2@&3

SET MARKUP HTML ON SPOOL ON HEAD "<TITLE>Admin Report PSL By Contract</TITLE><STYLE TYPE='TEXT/CSS'><!--BODY {background: ffffc6} --></STYLE>"

spool logs\bigS_with_root_cause.htm
select tab.sla_name, tab.global_rule_name, tab.psl_instance_id "instance id", tab.days "days",
       count (*) "agents", sum (tab.clusters) "cluster agents", days * sum (tab.clusters) "cluster agent days",
       sum (case when tab.time_unit = 'HOUR' then
                      days * 24 * clusters
                   when tab.time_unit = 'DAY'     then
                      days * clusters
                   when tab.time_unit = 'WEEK'    then
                      ceil (days  / 7) * clusters
                   when  tab.time_unit = 'MONTH'   then
                      ceil (days / 30.4375) * clusters
                   when  tab.time_unit = 'QUARTER' then
                      ceil (days / 91.3125) * clusters
                   when  tab.time_unit = 'YEAR'    then
                      ceil (days / 365.25) * clusters
                   end) "psl records",
        runtime_error, rh.reason_code
from t_recalculation_history rh,
        (select time_unit , decode (return_to , calculate_to , 0 , floor (calculate_to - decode (state , null , valid_from , state))) days , clusters, psl_instance_id, global_rule_name, sla_name, psl_rule_id,runtime_error, global_rule_id 
                  from (select tu.global_rule_name,
                               tu.time_unit    ,
                               tu.return_to    ,
                               tu.calculate_to ,
                               tu.valid_from   ,
                               clusters        ,
                               psl_instance_id,
                               sla_name,
                               psl_rule_id,
                               max (rs.timestamp) state,
                               runtime_error,
                               global_rule_id
                         from (select gr.global_rule_name,
                                      tu.rule_id                                                   ,
                                      tu.is_period                                                 ,
                                      tu.time_unit                                                 ,
                                      least (sysdate , sv.inactivation_date) calculate_to          ,
                                      sv.valid_from                                                ,
                                      least (nvl (tu.min_time_not_used     , sv.inactivation_date) ,
                                             nvl (tu.min_time_of_version   , sv.inactivation_date) ,
                                             nvl (tu.min_time_of_exception , sv.inactivation_date) ,
                                             case when tu.last_psl_cycle_date is null or tu.last_psl_cycle_date = '02-jan-1970' then
                                                sv.valid_from
                                             else
                                                sv.inactivation_date
                                             end ,
                                             sysdate) return_to ,
                                      case when r.is_clustered = 0 then
                                         1
                                      when r.is_all_items = 0 then
                                         (select count (*)
                                            from t_cluster_items ci
                                           where ci.rule_id = r.rule_id)
                                      else
                                         (select count (distinct rgm.child_id)
                                            from t_resource_group_members rgm
                                           where rgm.parent_id = r.cluster_id
                                             and rgm.create_version_status = 'ACTIVE'
                                             and rgm.create_version_date   < sv.inactivation_date
                                             and rgm.delete_version_date   > sv.valid_from)
                                      end clusters,
                                      s.sla_name,
                                      gr.psl_instance_id,
                                      r.psl_rule_id,
                                      tu.last_rt_error runtime_error,
                                      gr.global_rule_id
                                 from t_rules_time_units tu ,
                                      t_rules            r  ,
                                      t_global_rules     gr ,
                                      t_sla_versions     sv ,
                                      t_slas             s
                                where tu.rule_id         =  r.psl_rule_id
                                  and r.global_rule_id   =  gr.global_rule_id
                                  and r.sla_version_id   =  sv.sla_version_id
                                  and sv.sla_id          =  s.sla_id
                                  and tu.status          =  'ON'
                                  and sv.status          in ('EFFECTIVE' , 'NOT_EFFECTIVE')
                                  and s.sla_status       != 'ARCHIVED'
                                          and s.customer_id > 500
                                  and s.is_data_to_be_purged = 'N'
                                  and gr.psl_instance_id <> -1) tu ,
                              t_rule_states rs
                        where tu.rule_id   =  rs.rule_id        (+)
                          and tu.is_period =  rs.is_period      (+)
                          and tu.time_unit =  rs.time_unit_name (+)
                          and tu.return_to >= rs.timestamp      (+)
                     group by tu.sla_name,
                              tu.global_rule_name,
                              tu.psl_rule_id,
                              tu.rule_id      ,
                              tu.is_period    ,
                              tu.time_unit    ,
                              tu.calculate_to ,
                              tu.valid_from   ,
                              tu.return_to    ,
                              tu.clusters     ,
                              tu.psl_instance_id,
                              tu.runtime_error,
                              tu.global_rule_id) tab1 ) tab
                              where rh.metric_id (+)  = tab.global_rule_id
                              and days > 0
group by  tab.sla_name,  tab.global_rule_name, tab.days,  tab.psl_instance_id, tab.runtime_error, rh.reason_code 
order by days desc;
spool off
exit;