REM Service_Deskpre.cmd 
REM description: Service Desk PRE Script  
REM Contact : Shawn Walsh
REM Company: CA Technologies
REM Original Date: March 21 2013
REM Design purpose: Use to run anything needed before CACDF is called.
REM For Service Desk, we want to see if the native DIAG tool is available and if so, run that

echo off
cls

REM See if 12.7 and/or native Service Desk Diag tool is present
rem #############################################################
rem Simple routine that will change the current directory to 
rem to the $NX_ROOT\diag\rpt directory and run perlscript supp_diag.pl.
rem Usage:  supp_diag.cmd
rem #############################################################

set NX_TEMP_CMD=%TEMP%\cd_nx.cmd

rem ###########################################
rem get NX_ROOT and convert slashes
rem ###########################################

nx_env -d NX_ROOT |  pdm_gsub / \ > %NX_TEMP_CMD%

rem ###########################################
rem Invoke the command to set variable NX_ROOT
rem ###########################################

CALL %NX_TEMP_CMD%

rem ###########################################
rem if not error, put out our msg
rem ###########################################

if ERRORLEVEL 1 goto :cleanup
echo NX_ROOT set to %NX_ROOT%
rem ###########################################
rem Clean up our variables and file
rem ###########################################

:cleanup
del  %NX_TEMP_CMD%
set NX_TEMP_CMD=

IF EXIST %NX_ROOT%\diag\bin\supp_diag.cmd (
		REM Call any Product utilities for Log Gathering needed before CACDF
		echo "Service Desk has a native tool  included in 12.7 and later or from TEC469212.
		echo "We will launch to gather the logs and information."
		start /wait pdm_perl %NX_ROOT%\diag\bin\supp_diag.pl
		set product=Service_Desk_DiagRun
	)
	
	set uhome=%HOMEPATH:\=/%
:SetTrace
REM Put your steps to turn on trace here.

:CallUtil


:Main


echo "return to cacdf.cmd"





