' VB script used by : APM,
'
' Created by Sam Detweiler
' Purpose: Generate the product ini file. It adds a prefix "line<#>" to each line, This allow line manipulation 
' by Remote Engineer using the File command. For example:
'
' Content of tmp file:
' c:\Introscope\Agent
' d:\Program Files\CA\APM\Agent
' e:\Production\Env\CA\APM\Agent
'
' In apmpre.cmd:
' type tmp | cscript /nologo scripts\VBSs\ini_it.vbs > product_list.ini
'
' Result: Content of product_list.ini
' line1 c:\Introscope\Agent
' line2 d:\Program Files\CA\APM\Agent
' line3 e:\Production\Env\CA\APM\Agent
'
' In apm.txt:
' [file:product_list.ini[line2]]\ext\*
'
' Result: Remote engineer will collect the content of d:\Program Files\CA\APM\Agent\ext
'
' Change history:
' --------------
' Nov 18,2013 - by: morse06@ca.com - You can pass a string you would to suppress from each line. For example:
'
' Content of tmp file:
' c:\Introscope\Agent\bin\wilyAgent.dll
' d:\Program Files\CA\APM\Agent\bin\wilyAgent.dll
' e:\Production\Env\CA\APM\Agent\bin\wilyAgent.dll
'
' In apmpre.cmd:
' type tmp | cscript /nologo scripts\VBSs\ini_it.vbs \bin\wilyAgent.dll > product_list.ini
'
' Result: Content of product_list.ini
' line1 c:\Introscope\Agent
' line2 d:\Program Files\CA\APM\Agent
' line3 e:\Production\Env\CA\APM\Agent
'
' In apm.txt:
' [file:product_list.ini[line2]]\ext\*
'
' Result: Remote engineer will collect the content of d:\Program Files\CA\APM\Agent\ext




i = 1
Do until Wscript.StdIn.AtEndOfStream <> false 
        strInput = Wscript.StdIn.Readline
        
        If WScript.Arguments.Count > 0 Then
		
		If instr(strInput,Wscript.Arguments.Item(0)) > 0 Then
			strLeft=left(strInput,instr(strInput,Wscript.Arguments.Item(0))-1)
			if right(strInput,len(Wscript.Arguments.Item(0))) = Wscript.Arguments.Item(0) Then
				strRight=""
			Else
				strRight=right(strInput,len(strInput)-(instr(strInput,Wscript.Arguments.Item(0))+len(Wscript.Arguments.Item(0))))		
			End If
			
			strInput=strLeft+strRight
			wScript.echo "line" +cstr(i) + " " + strInput
			i= i+1
		End If
		
        Else
                wScript.echo "line" +cstr(i) + " " + strInput
                i= i+1
        End If
        
loop