'****************************************************************************
'*                                                                          *
'*  caprodreg.vbs - Display registry values from CA products		    *
'*                                                                          *
'****************************************************************************
const HKLM = &H80000002
const REG_SZ = 1
const REG_EXPAND_SZ = 2
const REG_BINARY = 3
const REG_DWORD = 4
const REG_MULTI_SZ = 7

Sub EchoKeyValues(RegObj, DefKey, SubKeyName)
	On error Resume Next
	Wscript.Echo vbCrLf & vbtab & "Subkey: " & SubKeyName & vbCrLf
	RegObj.EnumValues DefKey, SubKeyName, eValues, eTypes

	For i=0 to UBound(eValues)
		Select Case eTypes(i)

			Case REG_SZ
				RegObj.GetStringValue DefKey, SubKeyName,_
					eValues(i), sValue
				Wscript.Echo vbTab & vbTab & _
					"Key: " & eValues(i) & " Value SZ '" &_
					sValue & "'"

			Case REG_EXPAND_SZ
				RegObj.GetExpandedStringValue DefKey, _
					SubKeyName,_
					eValues(i), esValue
				Wscript.Echo vbTab & vbTab & _
					"Key: " & eValues(i) & " Value EXP_SZ '" &_
					esValue & "'"

			Case REG_BINARY
				RegObj.GetBinaryValue DefKey, _
					SubKeyName,_
					eValues(i), bValue
				Wscript.Echo vbTab & vbTab & _
					"Key: " & eValues(i) & " Value BIN '" &_
					bValue & "'"

			Case REG_DWORD
				RegObj.GetDWORDValue DefKey, _
					SubKeyName,_
					eValues(i), dwValue
				Wscript.Echo vbTab & vbTab & _
					"Key: " & eValues(i) & " Value DWORD '" &_
					dwValue & "'"

			Case REG_MULTI_SZ
				RegObj.GetMultiStringValue DefKey, _
					SubKeyName,_
					eValues(i), msValue
				Wscript.Echo vbTab & vbTab & _
					"Key: " & eValues(i) & " Value MULT_SZ '" &_
					msValue & "'"
		End Select 
	Next
	
'	Wscript.Echo vbtab & "Subkeys for " & SubKeyName & ":"
	RegObj.EnumKey DefKey, SubKeyName, eKeys
	For Each subkey in eKeys
		If subkey > "" Then _
			EchoKeyValues RegObj, DefKey, SubKeyName & "\" & subkey
	Next

End Sub

Set WshShell = WScript.CreateObject("WScript.Shell")
Set wmi = GetObject("winmgmts:")
Set RegProv = GetObject("winmgmts:root/DEFAULT:StdRegProv")

Wscript.Echo vbCrLf & "Getting Keys from 32bit Architecture:"
Wscript.Echo vbCrLf & "====================================="
Set objContext = CreateObject("WbemScripting.SWbemNamedValueSet")
objContext.Add "__ProviderArchitecture", 32
objContext.Add "__RequiredArchitecture", True
Set objLocator = CreateObject("WbemScripting.SWbemLocator")
Set RegProv = objLocator.ConnectServer("", "root/DEFAULT", "", "", , , , objContext).Get("StdRegProv")

RegProv.EnumKey HKLM, "SOFTWARE\ComputerAssociates\", sKeys
On error Resume Next
For Each cakey In sKeys
	Wscript.Echo vbCrLf & "CA Product: " & cakey
	EchoKeyValues RegProv, HKLM, "SOFTWARE\ComputerAssociates\" & cakey
Next

RegProv.EnumKey HKLM, "SOFTWARE\CA\", sKeys
On error Resume Next
For Each cakey In sKeys
	Wscript.Echo vbCrLf & "CA Product: " & cakey
	EchoKeyValues RegProv, HKLM, "SOFTWARE\CA\" & cakey
Next

RegProv.EnumKey HKLM, "SOFTWARE\Netegrity\", sKeys
On error Resume Next
For Each cakey In sKeys
    If NOT xmlout Then Wscript.Echo vbCrLf & "CA Product: " & cakey
    EchoKeyValues RegProv, HKLM, "SOFTWARE\Netegrity\" & cakey
Next

if WScript.Arguments.Count > 0 then
	RegProv.EnumKey HKLM, WScript.Arguments(0), sKeys
	On error Resume Next
	For Each cakey In sKeys
	    If NOT xmlout Then Wscript.Echo vbCrLf & "CA Product: " & cakey
	    EchoKeyValues RegProv, HKLM, WScript.Arguments(0) & cakey
	Next	 
end if

Wscript.Echo vbCrLf & "Getting Keys from 64bit Architecture:"
Wscript.Echo vbCrLf & "======================================"
Set objContext = CreateObject("WbemScripting.SWbemNamedValueSet")
objContext.Remove "__ProviderArchitecture"
objContext.Add "__ProviderArchitecture", 64
objContext.Add "__RequiredArchitecture", True
Set objLocator = CreateObject("WbemScripting.SWbemLocator")
Set RegProv = objLocator.ConnectServer("", "root/DEFAULT", "", "", , , , objContext).Get("StdRegProv")

RegProv.EnumKey HKLM, "SOFTWARE\ComputerAssociates\", sKeys
On error Resume Next
For Each cakey In sKeys
	Wscript.Echo vbCrLf & "CA Product: " & cakey
	EchoKeyValues RegProv, HKLM, "SOFTWARE\ComputerAssociates\" & cakey
Next

RegProv.EnumKey HKLM, "SOFTWARE\CA\", sKeys
On error Resume Next
For Each cakey In sKeys
	Wscript.Echo vbCrLf & "CA Product: " & cakey
	EchoKeyValues RegProv, HKLM, "SOFTWARE\CA\" & cakey
Next

RegProv.EnumKey HKLM, "SOFTWARE\Netegrity\", sKeys
On error Resume Next
For Each cakey In sKeys
    If NOT xmlout Then Wscript.Echo vbCrLf & "CA Product: " & cakey
    EchoKeyValues RegProv, HKLM, "SOFTWARE\Netegrity\" & cakey
Next

if WScript.Arguments.Count > 1 then
	RegProv.EnumKey HKLM, WScript.Arguments(0), sKeys
	On error Resume Next
	For Each cakey In sKeys
	    If NOT xmlout Then Wscript.Echo vbCrLf & "CA Product: " & cakey
	    EchoKeyValues RegProv, HKLM, WScript.Arguments(0) & cakey
	Next	 
end if

