Echo Off
===================================================================================================
rem  File finding product version and performing misc checks on product
rem ===================================================================================================
rem 
rem  1/ Common setup for all scritps:
SET productResultDir=.\results\checkup-results
SET productChecksFile=%productResultDir%\scripts_result_product_checks.txt
rem Check for the product update/patch folder 
rem if exist C:\UPM (
rem echo PRODUCT_CHECK_TEST_FOLDER/GOOD/UPM Patch folder found>%productChecksFile%
rem ) else (
rem echo PRODUCT_CHECK_TEST_FOLDER/ERROR/UPM Patch folder not found>%productChecksFile%
rem
rem updated by walch21 4/15/2015
rem



rem check MySql version
echo see if NYMYSQL51 is installed
sc query "NetQoS NQMySql51" | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto mysql51exists
if %ERRORLEVEL% EQU 1 goto nqmysql51


rem check nqmysql51 status if it is installed
:nqmysql51
echo checking NYMysql51 Status
sc query "NetQoS NQMySql51" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_NQMYSQL51/ERROR/"NetQoS NQMySql51 Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_NQMYSQL51/GOOD/"NetQoS NQMySql51 Service" Is Running>>%productChecksFile%
)
 
Echo Done checking NQMysql51
 
goto mysql51exists
 

:mysql51exists
sc query "NetQoS MySql51" | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto nqmysql56exists
if %ERRORLEVEL% EQU 1 goto mysql51

:mysql51
sc query "NetQoS MySql51" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_MYSQL51/ERROR/"NetQoS MySql51 Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_MYSQL51/GOOD/"NetQoS MySql51 Service" Is Running>>%productChecksFile%
)
 
echo Done Checking mysql51
goto harvestercheck
 

:nqmysql56exists
echo Checking if NQMysql56 exists
sc query "NetQoS NQMySql" | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto mysql56exists
if %ERRORLEVEL% EQU 1 goto nqmysql56

:nqmysql56
echo Checking Mysql56 Status
 
sc query "NetQoS NQMySql" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_NQMYSQL56/ERROR/"NetQoS NQMySql Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_NQMYSQL56/GOOD/"NetQoS NQMySql Service" Is Running>>%productChecksFile%
)
 
goto mysql56exists
 

:mysql56exists
sc query "NetQoS MySql" | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto harvestercheck
if %ERRORLEVEL% EQU 1 goto mysql56


rem check mysql 5.6 status
:mysql56
sc query "NetQoS MySql" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_MYSQL56/ERROR/"NetQoS MySql Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_MYSQL56/GOOD/"NetQoS MySql Service" Is Running>>%productChecksFile%
)
 
echo done checking mysql56
 
goto harvestercheck

 
 
 
rem check if Harvester is installed
:harvestercheck
sc query NetQoSHarvester | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto consolecheck
if %ERRORLEVEL% EQU 1 goto harv

rem check if Console is installed
:consolecheck
sc query "NetQoS Reporter Manager Service" | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto dsacheck
if %ERRORLEVEL% EQU 1 goto console

rem check if DSA is installed
:dsacheck
sc query "dsaloader" | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto exit
if %ERRORLEVEL% EQU 1 goto dsa


rem check for a runnnig Harvester Services
:harv
echo checking Harvester Services
echo ---------------------------

sc query NetQoSHarvester | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_HARVESTER/ERROR/"CA NFA Harvester Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_HARVESTER/GOOD/"CA NFA Harvester Service" Is Running>>%productChecksFile%
)

sc query CACollPollWS  | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_COLLPOLLWS/ERROR/"CA NFA Collection and Poller WebService" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_COLLPOLLWS/GOOD/"CA NFA Collection and Poller WebService" Is Running>>%productChecksFile%
)

sc query CANfaDataRetention | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DATARETNETION/ERROR/"CA NFA Data Retention Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DATARETNETION/GOOD/"CA NFA Data Retention" Is Running
)

sc query NetQoSProxies | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DNSSNMP/ERROR/"CA NFA DNS/SNMP Proxies Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DNSSNMP/GOOD/"CA NFA DNS/SNMP Proxies" Is Running
)

sc query CaNfaFileServer | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_FILESERVER/ERROR/"CA NFA File Server Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_FILESERVER/GOOD/"CA NFA File Server Service" Is Running>>%productChecksFile%
)

sc query CA_NFA_Poller | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_POLLER/ERROR/"CA NFA Poller Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_POLLER/GOOD/"CA NFA Poller Service" Is Running>>%productChecksFile%
)

sc query NetQoSReaper | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_REAPER/ERROR/"CA NFA Reaper Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_REAPER/GOOD/"CA NFA Reaper Service" Is Running>>%productChecksFile%
)

rem database issue checks

mysql -P3308 -D poller -N -s -r -e "select ifindex from persistent_map where ifindex is NULL;" | findstr /c:"NULL"
if errorlevel 1 ( 
echo PRODUCT_CHECK_POLLER_IFINDEX_NULL/GOOD/No NULL ifIndex values found in poller.persistent_map>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_POLLER_IFINDEX_NULL/ERROR/NULL ifIndex values found in poller.persistent_map>>%productChecksFile%
)

mysql -P3308 -D poller -N -s -r -e "select state from routers where state='RebootRefresh';" | findstr /c:"RebootRefresh"
if errorlevel 1 ( 
echo PRODUCT_CHECK_POLLER_REBOOTREFRESH/GOOD/Router States are good>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_POLLER_REBOOTREFRESH/WARN/Found Routers With RebootRefresh State>>%productChecksFile%
)

mysql -P3308 -D data_retention -N -s -r -e "select count(*) from settings where name='freeSpacePercentage' and value < 10;" | findstr /c:"1"
if errorlevel 1 ( 
echo PRODUCT_CHECK_DATA_RETENTION_FREE/GOOD/freeSpacePercentage set to at least 10% >>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_DATA_RETENTION_FREE/WARN/freeSpacePercentage is less than 10% >>%productChecksFile%
)

rem check harvester database to see if any tables are corrupt

mysql -P3308 -D harvester -N -s -r -e "show table status;" | findstr /c:"repair it"
if errorlevel 1 ( 
echo PRODUCT_CHECK_HARVESTER_TABLE_STATUS/GOOD/Harvester table Status OK>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_HARVESTER_TABLE_STATUS/ERROR/Corrupt tables found in Harvester database>>%productChecksFile%
)

rem check poller database to see if any tables are corrupt
mysql -P3308 -D poller -N -s -r -e "show table status;" | findstr /c:"repair it"
if errorlevel 1 ( 
echo PRODUCT_CHECK_POLLER_TABLE_STATUS/GOOD/Poller table Status OK>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_POLLER_TABLE_STATUS/ERROR/Corrupt tables found in Poller database>>%productChecksFile%
)

rem check data_retention database to see if any tables are corrupt
mysql -P3308 -D data_retention -N -s -r -e "show table status;" | findstr /c:"repair it"
if errorlevel 1 ( 
echo PRODUCT_CHECK_DATA_RETENTION_TABLE_STATUS/GOOD/Data_retention table Status OK>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_DATA_RETENTION_TABLE_STATUS/ERROR/Corrupt tables found in Data_Retention database>>%productChecksFile%
)




echo Checking for Console Services
echo -----------------------------

sc query "NetQoS Reporter Manager Service" | find "does not exist" >nul
if %ERRORLEVEL% EQU 0 goto end
if %ERRORLEVEL% EQU 1 goto console


rem check for running Console Services
:console

echo Running Console Service Check

sc query "NetQoS Reporter Manager Service"  | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_MANAGER/ERROR/"NetQoS Reporter Manager Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_MANAGER/GOOD/"NetQoS Reporter Manager Service" Is Running>>%productChecksFile%
)

sc query "nqserv"  | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_GENERAL/ERROR/"NetQoS Reporter/Analyzer General Services" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_GENERAL/GOOD/"NetQoS Reporter/Analyzer General Services" Is Running>>%productChecksFile%
)

sc query "NetQoSReporterAnalyzerPumpService"  | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_PUMP/ERROR/"NetQoS Reporter/Analyzer Pump Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_PUMP/GOOD/"NetQoS Reporter/Analyzer Pump Service" Is Running>>%productChecksFile%
)

sc query "nqreporter" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_QUERY/ERROR/"NetQoS Reporter/Analyzer Query Services" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_QUERY/GOOD/"NetQoS Reporter/Analyzer Query Services" Is Running>>%productChecksFile%
)

sc query "nqrawatchdog" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_WATCHDOG/ERROR/"NetQoS Reporter/Analyzer Watchdog" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_WATCHDOG/GOOD/"NetQoS Reporter/Analyzer Watchdog" Is Running>>%productChecksFile%
)

sc query "NetQoS ReporterAnalyzer Report Service" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_REPORT/ERROR/"NetQoS ReporterAnalyzer Report Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_REPORT/GOOD/"NetQoS ReporterAnalyzer Report Service" Is Running>>%productChecksFile%
)

sc query CAPerfCenter_SSO | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_SSO/ERROR/"CA Performance Center SSO" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_SSO/GOOD/"CA Performance Center SSO" Is Running>>%productChecksFile%
)

sc query "CA NFA RibSource" | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_RIB/ERROR/"CA NFA RibSource" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_RIB/GOOD/"CA NFA RibSource" Is Running>>%productChecksFile%
)


rem check for database issues
mysql -P3308 -D reporter -N -s -r -e "select ifindex from interfaces where ifindex=4294967295;" | findstr /c:"4294967295"
if errorlevel 1 ( 
echo PRODUCT_CHECK_REPORTER_4294967295/GOOD/ifIndex values are ok in reporter database>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_REPORTER_4294967295/ERROR/Interfaces found in reporter database with invalid ifIndex of 4294967295>>%productChecksFile%
)

mysql -P3308 -D reporter -N -s -r -e "select ttl from address_definitions where ttl='99y';" | findstr /c:"99y"
if errorlevel 1 ( 
echo PRODUCT_CHECK_ADDRESS_DEF_2038/GOOD/Address_Definitions Expire Interval in Range>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_ADDRESS_DEF_2038/ERROR/Address_Definitions Interval Out of Range>>%productChecksFile%
)

mysql -P3308 -D reporter -N -s -r -e "select count(*) from user_definitions where name='admin' and userlevel=1;" | findstr /c:"0"
if errorlevel 1 ( 
echo PRODUCT_CHECK_ADMIN_USERLEVEL/GOOD/'Admin' user found and has proper userlevel>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_ADMIN_USERLEVEL/ERROR/'Admin' user not found or has wrong userlevel>>%productChecksFile%
)

mysql -P3308 -D reporter -N -s -r -e "select propvalue from performance_center_properties where propname='WindowsAuthenticationEnabled' and propvalue='true' and priority in(1,2,3);" | findstr /c:"true"
if errorlevel 1 ( 
echo PRODUCT_CHECK_WINDOWS_AUTH/GOOD/Windows Authentication is not enabled>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_WINDOWS_AUTH/ERROR/Windows Authentication is enabled>>%productChecksFile%
)

mysql -P3308 -D reporter -t -e "select address, count(address) from harvesters group by address having count(address) > 1;" | findstr /c:"address"
if errorlevel 1 ( 
echo PRODUCT_CHECK_DUPLICATE_HARVESTERS/GOOD/No Duplicate Harvester Addresses found>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_DUPLICATE_HARVESTERS/ERROR/Duplicate Harvester Addresses found>>%productChecksFile%
)

mysql -P3308 -D reporter -N -s -r -e "select * from parameter_descriptions where parameter='flowinfolimit' and defaultvalue='1n';" | findstr /c:"1n"
if errorlevel 1 ( 
echo PRODUCT_CHECK_EOV_RETENTION/GOOD/Enterprise Overview Retention Limits OK>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_EOV_RETENTION/WARN/Enterprise Overview retention limits set to 1 Month which may cause some of your Enterprise Overview views to timeout.>>%productChecksFile%
)

mysql -P3308 -D reporter -N -s -r -e "select count(*) from interfaces where iftype in (18,37,100,101,102,103,104,134);" | findstr /c:"0"
if errorlevel 1 ( 
echo PRODUCT_CHECK_IFTYPE_REJECTION/WARN/'ifType_rejection' interfaces found>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_IFTYPE_REJECTION/GOOD/'ifType_rejection' interfaces not found>>%productChecksFile%
)

mysql -P3308 -D reporter -N -s -r -e "select * from application_mappings where nbar2Applicationid in (0,1);" | findstr /c:"Unclassified" /c:"Unknown"
if errorlevel 1 ( 
echo PRODUCT_CHECK_NBAR2_UNCLASSIFIED/GOOD/NBAR2 definitions are okay>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_NBAR2_UNCLASSIFIED/ERROR/NBAR2 definition "Unknown" or "Unlcassified" NBAR2 definitions found>>%productChecksFile%
)


rem check reporter database to see if any table are corrupt
mysql -P3308 -D reporter -N -s -r -e "show table status;" | findstr /c:"repair it"
if errorlevel 1 ( 
echo PRODUCT_CHECK_REPORTER_TABLE_STATUS/GOOD/Reporter table Status OK>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_REPORTER_TABLE_STATUS/ERROR/Corrupt tables found in Reporter database>>%productChecksFile%
)



goto :end

rem check for running DSA Services
:dsa

sc query CANfaDataRetention | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DATARETENTION/ERROR/"CA NFA Data Retention Service" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DATARETENTION/GOOD/"CA NFA Data Retention" Is Running>>%productChecksFile%
)

sc query DSALoader | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DSALOADER/ERROR/"CA NFA DSALoader" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DSALOADER/GOOD/"CA NFA DSALoader" Is Running>>%productChecksFile%
)

sc query CAPump | findstr /c:"RUNNING"
if errorlevel 1 ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DSAPUMP/ERROR/"CA NFA Pump" is not running>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_TEST_SRV_RUNNING_DSAPUMP/GOOD/"CA NFA Pump" Is Running>>%productChecksFile%
)

mysql -P3308 -D nqrptr -t -e "show table status;" | findstr /c:"_c " /c:"_h " /c:"_p" /c:"_tos" /c:"_as"
if errorlevel 0 ( 
echo PRODUCT_CHECK_DSA_ORPHANED_TABLES/GOOD/Leftover DSA interface tables not found>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_DSA_ORPHANED_TABLES/WARN/Leftover DSA interface tables found>>%productChecksFile%
)


rem check DSA's nqrptr database to see if any table are corrupt
mysql -P3308 -D nqrptr -N -s -r -e "show table status;" | findstr /c:"repair it"
if errorlevel 1 ( 
echo PRODUCT_CHECK_NQRPTR_TABLE_STATUS/GOOD/nqrptr table Status OK>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_NQRPTR_TABLE_STATUS/ERROR/Corrupt tables found in nqrptr database>>%productChecksFile%
)

rem check data_retention database to see if any tables are corrupt
mysql -P3308 -D data_retention -N -s -r -e "show table status;" | findstr /c:"repair it"
if errorlevel 1 ( 
echo PRODUCT_CHECK_DATA_RETENTION_TABLE_STATUS/GOOD/Data_retention table Status OK>>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_DATA_RETENTION_TABLE_STATUS/ERROR/Corrupt tables found in Data_retention database>>%productChecksFile%
)

rem check if data retention settings are at least 10%
mysql -P3308 -D data_retention -N -s -r -e "select count(*) from settings where name='freeSpacePercentage' and value < 10;" | findstr /c:"1"
if errorlevel 1 ( 
echo PRODUCT_CHECK_DATA_RETENTION_FREE/GOOD/freeSpacePercentage set to at least 10% >>%productChecksFile%
) else ( 
echo PRODUCT_CHECK_DATA_RETENTION_FREE/WARN/freeSpacePercentage is less than 10% >>%productChecksFile%
)

exit 0
