'****************************************************************************
'*                                                                          *
'*  getdrwatson.vbs - Generate list of drwatson related files		    *
'*                                                                          *
'*  Course of action:                                                       *
'*                                                                          *
'*	1. Create a file that will contain general drwatson config info	    *
'*	2. Determine location of drwatson log file(s) and add to list.
'*	3. Determine location of user.dmp and/or memory.dmp files and add   *
'*		to list.
'*                                                                          *
'*  List of files is returned to calling java program by echoing the file   *
'*  names to stdout.                                                        *
'*                                                                          *
'****************************************************************************
const HKLM = &H80000002
const REG_SZ = 1
const REG_EXPAND_SZ = 2
const REG_BINARY = 3
const REG_DWORD = 4
const REG_MULTI_SZ = 7


On error Resume Next
Set WshShell = WScript.CreateObject("WScript.Shell")
Set RegProv = GetObject("winmgmts:root/DEFAULT:StdRegProv")
Dim infofile, filetxt
Set infofile = CreateObject("Scripting.FileSystemObject")
Set filetext = infofile.CreateTextFile("drwatsoninfo.txt", True)

'** Get value of system debug settings from registry

RegProv.GetStringValue HKLM, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\AeDebug", "Debugger", debugcmd
RegProv.GetStringValue HKLM, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\AeDebug", "Auto", debugauto
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\AeDebug", "UserDebuggerHotKey", debughotkey

'** Get value of DrWatson settings from registry

RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "AppendToLogFile", drwapplog
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "CrashDumpType", drwdumptype
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "CreateCrashDump", drwcreatedump
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "DumpAllThreads", drwdumpallthreads
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "DumpSymbols", drwdumpsymbols
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "Instructions", drwinstructions
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "MaximumCrashes", drwmaxcrash
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "NumberOfCrashes", drwnumcrash
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "SoundNotification", drwsoundnote
RegProv.GetDWORDValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "VisualNotification", drwvisnote
RegProv.GetStringValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "CrashDumpFile", drwdumpfile
RegProv.GetStringValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "LogFilePath", drwlogpath
RegProv.GetStringValue HKLM, "SOFTWARE\Microsoft\DrWatson\", "WaveFile", drwwavefile

If drwlogpath Is Nothing Then 
	drwlogpath = "[env:ALLUSERSPROFILE]\Application Data\Microsoft\Dr Watson"
End If

filetext.WriteLine(vbtab & "Dr Watson settings" & vbcrlf)
filetext.WriteLine("Debug command (from AeDebug registry setting): " &_
	debugcmd)
filetext.WriteLine("Auto Flag: " & debugauto)
filetext.WriteLine("Hot Key: " & debughotkey)
filetext.WriteLine("")
filetext.WriteLine("Append To Log File: " & drwapplog)
filetext.WriteLine("Crash Dump Type: " & drwdumptype)
filetext.WriteLine("Create Crash Dump: " & drwcreatedump)
filetext.WriteLine("Dump All Threads: " & drwdumpallthreads)
filetext.WriteLine("Dump Symbols: " & drwdumpsymbols)
filetext.WriteLine("Instructions: " & drwinstructions)
filetext.WriteLine("Maximum Crashes: " & drwmaxcrash)
filetext.WriteLine("Number of Crashes: " & drwnumcrash)
filetext.WriteLine("Sound Notification: " & drwsoundnote)
filetext.WriteLine("Visual Notification: " & drwvisnote)
filetext.WriteLine("Crash Dump File: " & drwdumpfile)
filetext.WriteLine("Log File Path: " & drwlogpath)
filetext.WriteLine("Wave File: " & drwwavefile)
filetext.Close

Wscript.Echo "drwatsoninfo.txt"
Wscript.Echo drwdumpfile 
Wscript.Echo drwlogpath 


