''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' GetEvent script v1.0 by seanw@microsoft.com 4/13/2004
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

On Error Resume Next
Const ForReading = 1, ForWriting = 2, ForAppending = 8
strComputer = "."
if wscript.arguments.count <> 2 then
   wscript.echo "Usage: cscript " & wscript.scriptname & " logname outputfilename.csv"
   wscript.quit
end if

set fso = createobject("Scripting.FileSystemObject")
if err.number <> 0 then
   wscript.echo "Error 0x" & myHex(err.number,8) & ": creating FSO"
   wscript.echo err.source & " - " & err.description
   wscript.quit
end if

Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
if err.number <> 0 then
   wscript.echo "Error 0x" & myHex(err.number,8) & ": binding to WMI Service"
   wscript.echo err.source & " - " & err.description
   wscript.quit
end if

Set colItems = objWMIService.ExecQuery("Select * from Win32_NTLogEvent where Logfile='" & wscript.arguments(0) & "'",,48)
if err.number <> 0 then
   wscript.echo "Error 0x" & myHex(err.number,8) & ": executing WMI query"
   wscript.echo err.source & " - " & err.description
   wscript.quit
end if

set csvfile  = fso.OpenTextFile(wscript.arguments(1), ForWriting, True) ' overwrite existing file
 if err.number <> 0 then
    wscript.echo "Error 0x" & myHex(err.number,8) & ": " & err.source & " - " & err.description
    wscript.quit
 end if

csvfile.writeline "Log,DateTime,Type,EventID,Source,Category,Computer,User,Message"
For Each objItem in colItems
    if err.number <> 0 then
       wscript.echo "Error 0x" & myHex(err.number,8) & ": processing event record"
       wscript.echo err.source & " - " & err.description
       err.clear
    end if
    row = ""
    row = row & chr(34) & objItem.Logfile & chr(34) & ","
    row = row & chr(34) & Date2String(objItem.TimeGenerated) & chr(34) & ","
    if objItem.Type = "" then
       row = row & chr(34) & objItem.EventType & chr(34) & ","
    else
       row = row & chr(34) & objItem.Type & chr(34) & ","
    end if
    row = row & chr(34) & objItem.EventCode & chr(34) & ","
    row = row & chr(34) & objItem.SourceName & chr(34) & ","
    row = row & chr(34) & objItem.CategoryString & chr(34) & ","
    row = row & chr(34) & objItem.ComputerName & chr(34) & ","
    row = row & chr(34) & objItem.User  & chr(34) & ","
    message = FilterCtrlChars(objItem.Message)
    row = row & chr(34) & message & chr(34)
    csvfile.writeline row
Next

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function    : FilterCtrlChars(byval strRawData)
' Description : replace ctrl chars with escape strings
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
function FilterCtrlChars(byval strRawData)
   tmpstr = ""
   if not isNull(strRawData) then
      for x = 1 to len(strRawData)
          select case mid(strRawData,x,1)
             case vbtab
                tmpstr = tmpstr & "\t"
             case vbcr
                tmpstr = tmpstr & "\r"
             case vblf
                tmpstr = tmpstr & "\n"
             case vbformfeed
                tmpstr = tmpstr & "\f"
             case vbNullChar
                tmpstr = tmpstr & "\0"
             case else
                tmpstr = tmpstr & mid(strRawData,x,1)
          end select
      next
   end if
   FilterCtrlChars = tmpstr
end function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function    : Date2String(byval wmiDate)
' Description : reformat a WMI date
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function Date2String(byval wmiDate)
    if isNull(wmiDate) then
        Date2String = "(null)"
    else
        Date2String = Formatdatetime( Mid(wmiDate,5,2) & "/"  & Mid(wmiDate,7,2) & "/"  &_
        Mid(wmiDate,1,4)) & " " & formatdatetime( Mid(wmiDate,9,2) & ":" &_
        Mid(wmiDate,11,2) & ":" & Mid(wmiDate,13,2))
    end if
end function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function    : MyHex(byval num, byval pad)
' Description : pad hex
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function MyHex(byval num, byval pad)
    MyHex = string(pad-len(hex(num)),&H30) & hex(num)
end function
