@cls
@rem echo off
SETLOCAL EnableDelayedExpansion
@rem
@rem HAEMI01 : 04-10-14
@rem Change in logic to ask for Plex version
@rem Store PLEXVER to file usersprefs\PLEXVER for use in Plex.txt
@rem Check Plex.ini for File1,2,3,4,5 to see last 5 .mdl Model files used
@rem Store the model file path of the file chosen in usersprefs\MDL_FILE

@rem create directory to store preferences.
IF NOT EXIST usersprefs (
   mkdir usersprefs
)

@rem Plex Version Check
@rem If Plex executable exists then corisponding version exists. 
@rem Write existing paths to Plexpaths.out 
@rem Test
@rem IF EXIST plex.txt echo "found Plex.txt" > PlexFound.out
@rem  

IF EXIST "%homedrive%\Program Files\CA\Plex\6.1\bin\ob610CB.exe" echo %homedrive%\Program Files\CA\Plex\6.1\> usersprefs\Plexpaths.out
IF EXIST "%ProgramFiles(x86)%\CA\Plex\6.1\bin\ob610CB.exe" echo %ProgramFiles(x86)%\CA\Plex\6.1\>> usersprefs\Plexpaths.out 

IF EXIST "%homedrive%\Program Files\CA\Plex\7.0\bin\ob700CB.exe" echo %homedrive%\Program Files\CA\Plex\7.0\>> usersprefs\Plexpaths.out
IF EXIST "%ProgramFiles(x86)%\CA\Plex\7.0\bin\ob700CB.exe" echo %ProgramFiles(x86)%\CA\Plex\7.0\>> usersprefs\Plexpaths.out

IF EXIST "%homedrive%\Program Files\CA\Plex\7.1\bin\ob710CB.exe" echo %homedrive%\Program Files\CA\Plex\7.1\>> usersprefs\Plexpaths.out
IF EXIST "%ProgramFiles(x86)%\CA\Plex\7.1\bin\ob710CB.exe" echo %ProgramFiles(x86)%\CA\Plex\7.1\>> usersprefs\Plexpaths.out

IF EXIST "%homedrive%\Program Files\CA\Plex\7.2\bin\ob720CB.exe" echo %homedrive%\Program Files\CA\Plex\7.2\>> usersprefs\Plexpaths.out
IF EXIST "%ProgramFiles(x86)%\CA\Plex\7.2\bin\ob210CB.exe" echo %ProgramFiles(x86)%\CA\Plex\7.2\>> usersprefs\Plexpaths.out

@rem Create Ini file with existing Plex paths
for %%i in (usersprefs\Plexpaths.out) do (
	if not %%~zi lss 1 (
		type usersprefs\Plexpaths.out | cscript /nologo scripts\VBSs\ini_it.vbs > usersprefs\Plexpaths.ini
	) 
)	

@rem cleanup the temp file
del usersprefs\Plexpaths.out

if EXIST usersprefs\Plexpaths.ini (
	echo Found the below Plex instances:
	cscript /nologo scripts\VBSs\printpath.vbs usersprefs\Plexpaths.ini
	echo.
)

@rem Check the version to get the last 5 mdl files
@rem Change logic to gather the version of plex in any case (MOVE BEFORE MODEL DETECTION)
@rem if "%MODEL_FILE_PATH%." equ "." (
echo Please enter the Plex Version having the problem? 6.1, 7.0, 7.1, 7.2?^>^>
set /p PLEXVER=

echo %PLEXVER%>usersprefs\PLEXVER

@rem Verify 
IF EXIST "%ProgramFiles(x86)%\CA\Plex\%PLEXVER%\bin\*CB.exe" echo %ProgramFiles(x86)%\CA\Plex\%PLEXVER%\>usersprefs\PLEXPATH
@rem If 64 bit path is found overwrite PLEXPATH
IF EXIST "%homedrive%\Program Files\CA\Plex\%PLEXVER%\bin\*CB.exe" echo %homedrive%\Program Files\CA\Plex\%PLEXVER%\>usersprefs\PLEXPATH

@rem PLEXPATH contains the path to the Plex version the customer chose 

@rem Detect the last 5 and display here asking them to choose the corrisponding entry
@rem echo "Please choose the Model File path from the list above or hit enter to proceed without a model"
@rem
@rem
echo =====================================================
echo Choose the number for Model file you are using OR hit enter to skip model collection
echo =====================================================
type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File1"
type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File2"
type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File3"
type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File4"
type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File5"
echo =====================================================
echo "Please type the corresponding Number and hit enter>>"
set /p _mdl=

if ["%_mdl%"] == ["1"] type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File1">usersprefs\MDL_FILE
if ["%_mdl%"] == ["2"] type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File2">usersprefs\MDL_FILE
if ["%_mdl%"] == ["3"] type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File3">usersprefs\MDL_FILE
if ["%_mdl%"] == ["4"] type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File4">usersprefs\MDL_FILE
if ["%_mdl%"] == ["5"] type "%HOMEDRIVE%\Users\%USERNAME%\My Documents\CA\Plex\%PLEXVER%\plex.ini" | findstr "^File5">usersprefs\MDL_FILE

echo Setting below path as Model file location
type usersprefs\MDL_FILE
